/*!
 * \file   test.cxx
 * \brief    
 * \author th202608
 * \date   28/06/2024
 */

#include <cmath>
#include <cassert>
#include <cstdlib>
#include <iostream>
#include <type_traits>

extern int enzyme_dup;
extern int enzyme_dupnoneed;
extern int enzyme_out;
extern int enzyme_const;

template < typename return_type, typename ... T >
return_type __enzyme_fwddiff(void*, T ... );

template <typename FunctionPointerType, typename ScalarVariable>
auto diff(FunctionPointerType fct, const ScalarVariable x) //
  requires((std::is_invocable_v<const FunctionPointerType, const ScalarVariable>)&&//
	   ((std::is_pointer_v<FunctionPointerType>)&&  //
	    (std::is_function_v<std::remove_pointer_t<FunctionPointerType>>))) {
  const auto ptr = reinterpret_cast<void*>(fct);
  return __enzyme_fwddiff<double>(ptr, enzyme_dup, x, 1.0);
}  // end of diff

constexpr double f(const double x) noexcept{return std::cos(x);};

int main() {
  const auto v = double{1};
  // works fine
  std::cout << "df: " << diff(f, v) << '\n';
  // segfaults
  std::cout << "df: " << diff(static_cast<double(*)(double)>(std::cos), v) << '\n';
  return EXIT_SUCCESS;
}
